{PR-1.}
uses crt, graph;
const a1=0.01; a2=0.0075; a3=0.005; a4=0.0025; g1=0.02;
g2=0.002; g3=0.0002; g4=0.00002; dt=0.01; Mt=0.25; Mz=5;
Var t,U,Z1,Z2,Z3,Z4,Z,Pr,S,k: real; DV,MV:integer;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Repeat t:=t+dt; U:=0; k:=0;
  If (t<500) then begin U:=40; k:=1; end;
  If (t>800)and(t<1300) then begin U:=60; k:=1; end;
  If (t>1600)and(t<2100) then begin U:=80; k:=1; end;
  Z:=Z1+Z2+Z3+Z4;
  Z1:=Z1+k*a1*(U-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt-k*a3*Z2*dt;
  Z3:=Z3+k*a3*Z2*dt-g3*Z3*dt-k*a4*Z3*dt;
  Z4:=Z4+k*a4*Z3*dt-g4*Z4*dt;
  Pr:=(Z2/4+Z3/2+Z4)/(Z+0.001);
  S:=S+k*(U-Z)*dt;
  circle(10+round(Mt*t),450-round(Mz*U),1);
  circle(10+round(Mt*t),451-round(Mz*U),1);
  circle(10+round(Mt*t),450-round(Mz*Z),1);
  circle(10+round(Mt*t),451-round(Mz*Z),1);
  circle(10+round(Mt*t),450-round(Mz*(Z2+Z3+Z4)),1);
  circle(10+round(Mt*t),451-round(Mz*(Z2+Z3+Z4)),1);
  circle(10+round(Mt*t),450-round(Mz*(Z3+Z4)),1);
  circle(10+round(Mt*t),451-round(Mz*(Z3+Z4)),1);
  circle(10+round(Mt*t),450-round(Mz*Z4),1);
  circle(10+round(Mt*t),451-round(Mz*Z4),1);
  {circle(10+round(Mt*t),450-round(150*Pr),1);
  circle(10+round(Mt*t),450-round(S/100),1);
  circle(10+round(Mt*t),450-round(150),1);}
until KeyPressed; CloseGraph;
END.

{PR-2}
uses crt, graph;                           {Free Pascal}
const a1=0.01; a2=0.003; g1=0.005; g2=0.0001;
      dt=0.01; Mt=0.2; Mz=2.9;
var t,U,Z1,Z2,Z3,Z4,Z,Pr,S,k: real; DV,MV: integer;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Repeat t:=t+dt; U:=0; k:=0;
  If (t<300) then begin U:=0.15*t+20; k:=1; end;
  If (t>600)and(t<900) then begin
                               U:=0.15*(t-600)+50; k:=1; end;
  If (t>1200)and(t<1500) then begin
                              U:=0.15*(t-1200)+90; k:=1; end;
  Z:=Z1+Z2+Z3+Z4; Pr:=Z2/(Z+0.001);
  Z1:=Z1+k*a1*(U-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt;
  circle(10+round(Mt*t),450-round(Mz*Z),1);
  circle(10+round(Mt*t),450-round(Mz*(Z2)),1);
  circle(10+round(Mt*t),450-round(Mz*(U)),1);
  circle(10+round(Mt*t),450-round(150*Pr),1);
until KeyPressed; CloseGraph;
END.

{PR-3}
uses crt, graph;
const a1=0.01; a2=0.002; N=3; Ur=60;
g1=0.005; g2=0.0001; dt=0.8; Mt=0.35; Mz=2;
var Dl,Dl1,min,UU,t,Z1,Z2,Z,Zn,Zn2,Pr,Sum,S1,g,k:real;
i,kk:integer; S: array[0..N] of real; F:string; DV,MV:integer;
Procedure Raschet;
begin  t:=0; Sum:=0; Z1:=0; Z2:=0; Zn:=0;
Repeat t:=t+dt; k:=0; i:=round(t/10); UU:=Z+30;
  If (t<Dl)or((t>500)and(t<500+Dl))or((t>1000)and(t<1000+Dl)) then k:=1;
  Z1:=Z1+k*a1*(UU-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt; Z:=Z1+Z2;
  Sum:=Sum+k*abs(UU-Z)*dt;
until (t>1600)or(KeyPressed); Zn:=Z; Zn2:=Z2;
end;
Procedure Draw;
begin t:=0;  Z1:=0; Z2:=0; Z:=0; cleardevice;
Repeat t:=t+dt; k:=0; UU:=Z+30;
  If (t<Dl)or((t>500)and(t<500+Dl))or((t>1000)and(t<1000+Dl)) then k:=1;
  Z1:=Z1+k*a1*(UU-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt; Z:=Z1+Z2;
  circle(10+round(Mt*t),450-round(Mz*Z),1);
  circle(10+round(Mt*t),451-round(Mz*Z),1);
  circle(10+round(Mt*t),450-round(Mz*Ur),1);
  circle(10+round(Mt*t),450-round(Mz*(Z2)),1);
  circle(10+round(Mt*t),451-round(Mz*(Z2)),1);
  circle(10+round(Mt*t),450-round(Mz*(k*UU)),1);
  circle(10+round(Mt*t),451-round(Mz*(k*UU)),1);
until (t>1600)or(KeyPressed); end;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Randomize; min:=1E+6; Dl:=450;
Repeat Dl1:=Dl; Raschet; S1:=Sum;
  If Sum<min then min:=Sum;
  Dl:=Dl+random(160)/10-8;
  If Dl>450 then Dl:=450; Raschet;
  If (Sum>min)or(Zn<Ur)or(Zn2<0.7*Ur) then
                 begin Dl:=Dl1; end; g:=0;
  If (Sum<=min)and(Zn>Ur)and(Zn2>0.7*Ur) then begin
    Draw; circle(10,round(min/200),3); str(Sum,F);
    OutTextXY(20,20,F); str(Dl,F); OutTextXY(20,50,F); end;
until Keypressed; CloseGraph;
END.

{PR-4}
uses crt, graph;                                       
const a1=0.01; a2=0.002; N=5; Ur=90; g1=0.005;
      g2=0.0001; dt=0.8; Mt=0.25; Mz=2.1;
var min,UU,t,Z1,Z2,Z,Zn,Zn2,Pr,Sum,S1,g: real;
   i,k,kk,DV,MV:integer; S,U,U1: array[0..N] of real;
Procedure Raschet;
begin t:=0; Sum:=0; Z1:=0; Z2:=0; Zn:=0;
For i:=1 to N do S[i]:=0;
Repeat t:=t+dt; k:=0; i:=round(t/10);
  If t<200 then begin UU:=U[1]; k:=1;
                      S[1]:=S[1]+k*abs(UU-Z)*dt; end;
  If (t>400)and(t<600) then begin UU:=U[2]; k:=1;
                      S[2]:=S[2]+k*abs(UU-Z)*dt; end;
  If (t>800)and(t<1000) then begin UU:=U[3]; k:=1;
                      S[3]:=S[3]+k*abs(UU-Z)*dt; end;
  If (t>1200)and(t<1400) then begin UU:=U[4]; k:=1;
                      S[4]:=S[4]+k*abs(UU-Z)*dt; end;
  If (t>1600)and(t<1800) then begin UU:=U[5]; k:=1;
                      S[5]:=S[5]+k*abs(UU-Z)*dt; end;
  If UU>=Z then Z1:=Z1+k*a1*(UU-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  If UU<Z then Z1:=Z1-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt; Z:=Z1+Z2;
  Sum:=Sum+k*abs(UU-Z)*dt;
until (t>2200)or(KeyPressed); Zn:=Z; Zn2:=Z2; end;
Procedure Draw;
begin t:=0;  Z1:=0; Z2:=0; Z:=0; cleardevice;
Repeat t:=t+dt; k:=0;
  If t<200 then begin UU:=U[1]; k:=1; end;
  If (t>400)and(t<600) then begin UU:=U[2]; k:=1; end;
  If (t>800)and(t<1000) then begin UU:=U[3]; k:=1; end;
  If (t>1200)and(t<1400) then begin UU:=U[4]; k:=1; end;
  If (t>1600)and(t<1800) then begin UU:=U[5]; k:=1; end;
  If UU>=Z then Z1:=Z1+k*a1*(UU-Z)*dt-g1*Z1*dt-k*a2*Z1*dt;
  If UU<Z then Z1:=Z1-g1*Z1*dt-k*a2*Z1*dt;
  Z2:=Z2+k*a2*Z1*dt-g2*Z2*dt; Z:=Z1+Z2;
  circle(10+round(Mt*t),450-round(Mz*Z),1);
  circle(10+round(Mt*t),450-round(Mz*Ur),1);
  circle(10+round(Mt*t),450-round(Mz*(Z2)),1);
  circle(10+round(Mt*t),450-round(Mz*(UU)),1);
until (t>2200)or(KeyPressed); end;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Randomize; min:=1E+7;
For i:=1 to N do U[i]:=20+40*i;
Repeat For i:=1 to N do U1[i]:=U[i]; Raschet; S1:=Sum;
  If Sum<min then min:=Sum;
  For i:=1 to N do begin U[i]:=U[i]+random(800)/100-4;
  If U[i]<0 then U[i]:=0; end; Raschet;
  If (Sum>min)or(Zn<Ur){or(Zn2<0.6*Ur)} then
                       For i:=1 to N do U[i]:=U1[i]; g:=0;
  For i:=1 to N do If S[i]>75*200 then g:=1;
  If (g=0)and(Sum<=min)and(Zn>Ur){and(Zn2>0.6*Ur)} then
             begin Draw; circle(10,round(min/200),3); end;
until Keypressed; CloseGraph;
END.


{PR-5}
uses crt, graph;                                       
const a1=0.005; a2=0.002; g=0.0002; dt=0.2;
      b=0.03; Mt=0.1; N=195;
var DV,MV,i,k,r:integer; Z,Z1,Z2,U,t,p,x,Tu,Tp: real;
    Z0: array[1..N]of integer; usl:boolean;
Procedure Test;
begin r:=1; p:=1/(1+exp(-b*(Z-Z0[i]))); x:=random(100)/100;
If (x<p{Z>Z0[i]/2})and(usl) then begin
             i:=i+1; circle(round(Mt*t),10,2); r:=0; end
                         else circle(round(Mt*t),30,2); end;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi'); Randomize;
For i:=1 to N do Z0[i]:=10+15*i; 
i:=1; t:=dt; Z1:=0; Z2:=0; Tu:=600; Tp:=600;
Repeat t:=t+dt; inc(k);
 { If t<4300 then U:=r*(Z+40) else r:=0;}
  usl:=(t<Tu)or((t>Tu+Tp)and(t<2*Tu+Tp))or((t>2*Tu+2*Tp)
  and(t<3*Tu+2*Tp))or((t>3*Tu+3*Tp)and(t<4*Tu+3*Tp));
  If usl then U:=r*(Z+40) else r:=0; Z:=Z1+Z2;
  If U>Z then Z1:=Z1+a1*r*(U-Z)*dt-g*Z1*dt-a2*r*Z1*dt
                                 else Z1:=Z1-g*Z1*dt;
  If Z1>0 then Z2:=Z2+a2*r*Z1*dt-g*Z2*dt/10
                              else Z2:=Z2-g*Z2*dt/10;
  If k mod 100=0 then Test;
  If i>N then i:=N; If k=1000 then k:=0;
  circle(round(Mt*t),450-round(Z0[i]),1);
  circle(round(Mt*t),450-round(Z1+Z2),2);
  circle(round(Mt*t),450-round(Z2),2);
  circle(round(Mt*t),450-round(U),1);
until (Keypressed); Closegraph;
END.


{PR-6}
uses crt, graph; const N=8; Mt=1; a=0.15; dt=1;
var x,y,pp:real; i,j,d,t,r,u,k,l,M,h,kk,flag,DM,DV,MV:integer;
O: array[0..40] of integer; p: array[0..40] of real;
BEGIN x:=24; M:=200; DV:=Detect;
InitGraph(DV,MV,'c:\bp\bgi'); Randomize;
For i:=1 to N do p[i]:=0.05;
For d:=1 to 50 do begin
  O[1]:=1; j:=1;
  Repeat i:=j; k:=0; flag:=1; {=RESHENIE=}
    Repeat circle(Mt*t,450-10*O[i],2);
      If r=O[i]-1 then line(Mt*t,450-10*O[i],Mt*u,450-10*r);
      r:=O[i]; u:=t; inc(i); t:=t+dt; x:=x+157.3+random(87);
      If x>M then Repeat x:=x-M; until x<M; y:=x/M;
      If y<p[O[i-1]] then O[i]:=O[i-1]+1 else begin
        flag:=0; O[i]:=-1; circle(Mt*t,450+10,1); end; inc(k);
    until (Keypressed)or(k>=N+2)or((O[i]=N)and(flag=1));
    {=PROVERKA=}j:=1; h:=1;
    For l:=1 to N do If (O[l+1]=O[l]+1)and(h=1)
                                  then inc(j) else h:=0;
    For l:=1 to j+1 do p[l]:=p[l]+a*(1-p[l]); pp:=1;
    For l:=1 to N do pp:=pp*p[l]; O[1]:=1; r:=0;
    circle(Mt*t,300-round(150*pp),2); t:=t+2*dt; {j:=1;}
  until (Keypressed)or(j=N);
  If j=N then circle(Mt*(t-1),450-12*N,3); j:=1;
  For l:=1 to N do O[l]:=0; r:=0;
  If (flag=1) then For l:=1 to N do p[l]:=p[l]+a*(1-p[l]);
  pp:=1;
end; Repeat until KeyPressed; CloseGraph;
END.


{PR-7}
uses crt, graph;                         { Free Pascal }
const p: array [1..6]of real= (0.6,0.5,0.4,0.7,0.6,0);
var zz,dv,mV,kk,i,k,shag,op1:integer;sluch,ver,S:real;
R:boolean; x,y,op:array[1..1501]of integer; Label m;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');randomize;
i:=1; op[1]:=1; k:=1; x[1]:=320; y[1]:=40; shag:=1;
R:=true; circle(x[1],y[1],3);
Repeat inc(shag); inc(i); sluch:=random(100)/100;
  If sluch<p[op[i-1]] then op[i]:=op[i-1]+1 else
      begin m: op1:=round(random(50)/10)+1;
        If (op1=op[i-1]+1)or(op1=op[i-1])
              then goto m else op[i]:=op1;
      end;
  If op[i]-op[i-1]=1 then begin {write(' verno');} end
                                         else R:=false;
  ver:=exp(-0.1*shag); sluch:=random(100)/100;
  If shag>7 then begin shag:=1; op[i]:=1;
  R:=true; inc(k);x[1]:=320; y[1]:=40;
  end else begin zz:=op[i];
  x[shag]:=x[shag-1]+round(250/shag*cos(2*3.14*zz/15));
  y[shag]:=y[shag-1]+round(250/shag*sin(2*3.14*zz/15));
  line(x[shag-1],y[shag-1],x[shag],y[shag]);
  circle(x[shag],y[shag],2);
  rectangle(5*i,450-10,5*(i-1),450-10*op[i]); delay(10);
  end;
until ((op[i]=5)and(R=true))or(i>1500)or(Keypressed);
inc(kk); S:=S+i; shag:=1; x[1]:=320; y[1]:=40;
Repeat until KeyPressed; Closegraph;
END.

